#!/opsw/util/python/bin/python
#******************************************************************************
# ESO/DFS
#
# "@(#) $Id: ngamsTileCompress.py,v 1.1 2006/05/18 10:47:41 jknudstr Exp $"
#
# Who       When        What
# --------  ----------  -------------------------------------------------------
# jknudstr  18/05/2006  Created
#

"""
Command line utility + function to tile compress a FITS file.
For now the 'imcopy' utility of the CFITSIO package is invoked for this.
"""

import sys, time, commands


from   ngams import *


def ngamsTileCompress(filename):
    """
    Tile compress the referenced file.

    filename:   Filename (string).

    Returns:    Void.
    """
    tmpFilename = filename + ".tmp"
    try:
        comprCmd = "imcopy %s '%s[compress]'" % (filename, tmpFilename)
        info(3,"Command to tile compress file: %s" % comprCmd)
        stat, out = commands.getstatusoutput(comprCmd)
        if (stat != 0):
            msg = "Error compressing file: %s. Error: %s" %\
                  (filename, stat.replace("\n", "   "))
            raise Exception, msg
        mvFile(tmpFilename, filename)
        info(3,"Successfully tile compressed file: %s" % filename)
    except Exception, e:
        rmFile(tmpFilename)
        raise Exception, e
        

if __name__ == '__main__':
    """
    Main routine to calculate checksum for a file given as input parameter.
    """
    setLogCond(0, "", 0, "", 3)
    if (len(sys.argv) != 2):
        print "\nCorrect usage is:\n"
        print "% ngamsTileCompress.py <filename>\n"
        sys.exit(1)
    ngamsTileCompress(sys.argv[1])


# EOF
